from car_util import * # yeahhh don't do this


############
# Cockpit floor
############

def cockpit_floor_pts(t, offs):
    # floor
    base = []
    for j, wd in enumerate([-wpoints[-2], -wpoints[2],
                             wpoints[2], wpoints[-2]]):
        p = []
        base.append(p)
        fl = copy(middle_fwd)
        fl.reverse()
        extra = 0
        if j in [0, 3]:
            extra = 0.06
        for i, d in enumerate(fl[:-1]):
            depth = d + offs[1]
            if i == 0:
                depth -= cockpit_floor_slope
            # move floor inwards slightly, for passengers
            w = wd
            if i == 0 and j == 2: w -= 0.04 # for floor-support
            if i == 0 and j == 1: w += 0.04 # for floor-support
            if i in [1, 2] and j == 1:
                w += 0.10
            if i in [1, 2] and j == 2:
                w -= 0.10
            if i in [3] and j == 1:
                w += 0.04
            if i in [3] and j == 2:
                w -= 0.04
            # move outer edges out slightly to make room for metal frame
            if j in [3]:
                w += 0.01
            if j in [0]:
                w -= 0.01

            pos = [w + offs[0], depth, h0 + offs[2] + extra]
            p.append(pos)
            t.add_joint(pos)

    return base

class Floor(Group):

    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def make(self, frontbase_pts, offs):
        base = cockpit_floor_pts(self, offs)

        # horizontal pipes, front-wise
        for i in range(len(base[1])):
            p = base[i]
            for j in range(len(p)-1):
                diam = dthin
                offs1 = AUTO
                offs2 = AUTO
                if i in [0, len(base[i])-1]:
                    diam = dthick
                    #offs1 = jfwd0
                    #offs2 = jback0
                if j == 0 and i not in [0, len(base[i])-1]:
                    offs1 = jfwd
                    offs2 = jback
                self.add_pipe(p[j], p[j+1], diam, offs1, offs2)

        # horizontal pipes, width-wise
        for i in range(len(base)-1):
            p = base[i]
            for j in range(len(base[0])):
                self.add_pipe(base[i][j], base[i+1][j], dthin)

        # horizontal pipes, diagonal
        for i in range(len(base)-1):
            p = base[i]
            for j in range(len(base[0])-1):
                if i == 0:
                    self.add_pipe(base[i][j], base[i+1][j+1], dthin)
                else:
                    self.add_pipe(base[i+1][j], base[i][j+1], dthin)

        # join to base
        for i in range(len(base)):
            offs1 = jfwd
            offs2 = jback
            diam = dthin
            if i in [0, len(base[i])-1]:
                diam = dthick
                offs1 = jfwd0
                offs2 = jback0
            self.add_pipe(base[i][-1], frontbase_pts[i][0], diam)#, offs1, offs2)

        for i in range(len(base)-1):
            if i == len(base)-2:
                self.add_pipe(base[i][-1], frontbase_pts[i+1][0], dthin)
            else:
                self.add_pipe(base[i+1][-1], frontbase_pts[i][0], dthin)

        return base, self

